# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/Panzer clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "Panzer requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/Panzer build
## ---------------------------------------------------------------------------

set(Panzer_CXX_COMPILER "/usr/lib64/mpich/bin/mpicxx")

set(Panzer_C_COMPILER "/usr/lib64/mpich/bin/mpicc")

set(Panzer_Fortran_COMPILER "/usr/lib64/mpich/bin/mpif90")
# Deprecated!
set(Panzer_FORTRAN_COMPILER "/usr/lib64/mpich/bin/mpif90") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/Panzer build
## ---------------------------------------------------------------------------

## Give the build type
set(Panzer_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(Panzer_CXX_FLAGS [[ ]])

set(Panzer_C_FLAGS [[ -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -m64 -march=x86-64-v2 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fPIC -w -I/usr/include/mpich-x86_64 -fopenmp ]])

set(Panzer_Fortran_FLAGS [[ ]])
# Deprecated
set(Panzer_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(Panzer_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(Panzer_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64/mpich/lib")
set(Panzer_BUILD_SHARED_LIBS "ON")

set(Panzer_LINKER /usr/bin/ld)
set(Panzer_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(Panzer_INSTALL_DIR "/usr")

## List of package include dirs
set(Panzer_INCLUDE_DIRS "")

## List of package library paths
set(Panzer_LIBRARY_DIRS "")

## List of package libraries
set(Panzer_LIBRARIES "PanzerMiniEM::panzer-mini-fe;PanzerAdaptersSTK::panzer-stk;PanzerDiscFE::panzer-disc-fe;PanzerDofMgr::panzer-dof-mgr;PanzerCore::panzer-core;Piro::piro;ROL::rol;Stokhos::stokhos_muelu;Stokhos::stokhos_muelu_pce_openmp;Stokhos::stokhos_muelu_mp_16_openmp;Stokhos::stokhos_ifpack2;Stokhos::stokhos_ifpack2_pce_openmp;Stokhos::stokhos_ifpack2_mp_16_openmp;Stokhos::stokhos_amesos2;Stokhos::stokhos_amesos2_mp_16_openmp;Stokhos::stokhos_xpetra;Stokhos::stokhos_xpetra_pce_openmp;Stokhos::stokhos_xpetra_mp_16_openmp;Stokhos::stokhos_tpetra;Stokhos::stokhos_tpetraext_pce_openmp;Stokhos::stokhos_tpetra_pce_openmp;Stokhos::stokhos_tpetra_sd_pce_openmp;Stokhos::stokhos_tpetraext_mp_16_openmp;Stokhos::stokhos_tpetra_mp_16_openmp;Stokhos::stokhos_tpetra_sd_mp_16_openmp;Stokhos::stokhos_sacado;Stokhos::stokhos;Tempus::tempus;Rythmos::rythmos;MueLu::muelu-adapters;MueLu::muelu;NOX::locatpetra;NOX::locathyra;NOX::locaepetra;NOX::localapack;NOX::loca;NOX::noxepetra;NOX::noxlapack;NOX::nox;Phalanx::phalanx;Percept::percept;STKExprEval::stk_expreval;STKTransfer::stk_transfer_impl;STKSearch::stk_search;STKIO::stk_io_util;STKIO::stk_io;STKMesh::stk_mesh_base;STKTopology::stk_topology;STKMath::stk_math;STKUtil::stk_util_command_line;STKUtil::stk_util_diag;STKUtil::stk_util_registry;STKUtil::stk_util_env;STKUtil::stk_util_parallel;STKUtil::stk_util_util;Intrepid2::intrepid2;Intrepid::intrepid;Teko::teko;Stratimikos::stratimikos;Stratimikos::stratimikosbelos;Stratimikos::stratimikosamesos2;Stratimikos::stratimikosaztecoo;Stratimikos::stratimikosamesos;Stratimikos::stratimikosml;Stratimikos::stratimikosifpack;Ifpack2::ifpack2-adapters;Ifpack2::ifpack2;Anasazi::anasazitpetra;Anasazi::ModeLaplace;Anasazi::anasaziepetra;Anasazi::anasazi;SEACASAprepro_lib::aprepro_lib;SEACASIoss::io_info_lib;SEACASIoss::Ionit;SEACASIoss::Iotr;SEACASIoss::Iohb;SEACASIoss::Iogs;SEACASIoss::Iotm;SEACASIoss::Iogn;SEACASIoss::Iovs;SEACASIoss::Iopg;SEACASIoss::Ioex;SEACASIoss::Ioss;SEACASExodus::exodus;Amesos2::amesos2;ShyLU_NodeBasker::shylu_nodebasker;ShyLU_NodeTacho::tacho;ShyLU_NodeHTS::shylu_nodehts;Belos::belosxpetra;Belos::belostpetra;Belos::belosepetra;Belos::belos;ML::ml;Ifpack::ifpack;Zoltan2Core::zoltan2;Pamgen::pamgen_extras;Pamgen::pamgen;Amesos::amesos;Galeri::galeri-xpetra;Galeri::galeri-epetra;AztecOO::aztecoo;Isorropia::isorropia;Xpetra::xpetra-sup;Xpetra::xpetra;ThyraTpetraAdapters::thyratpetra;ThyraEpetraExtAdapters::thyraepetraext;ThyraEpetraAdapters::thyraepetra;ThyraCore::thyracore;TrilinosSS::trilinosss;TpetraCore::tpetraext;TpetraCore::tpetrainout;TpetraCore::tpetra;TpetraCore::tpetraclassic;TpetraTSQR::kokkostsqr;EpetraExt::epetraext;Triutils::triutils;Shards::shards;Zoltan::zoltan;Epetra::epetra;MiniTensor::minitensor;Sacado::sacado;RTOp::rtop;KokkosKernels::kokkoskernels;TeuchosKokkosComm::teuchoskokkoscomm;TeuchosKokkosCompat::teuchoskokkoscompat;TeuchosRemainder::teuchosremainder;TeuchosNumerics::teuchosnumerics;TeuchosComm::teuchoscomm;TeuchosParameterList::teuchosparameterlist;TeuchosParser::teuchosparser;TeuchosCore::teuchoscore;KokkosSimd::kokkossimd;KokkosAlgorithms::kokkosalgorithms;KokkosContainers::kokkoscontainers;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(Panzer_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(Panzer_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(Panzer_TPL_LIBRARIES "DLlib::all_libs;Eigen::all_libs;SCALAPACK::all_libs;AMD::all_libs;UMFPACK::all_libs;SuperLU::all_libs;Netcdf::all_libs;HDF5::all_libs;Zlib::all_libs;Boost::all_libs;LAPACK::all_libs;BLAS::all_libs;MPI::all_libs;Pthread::all_libs;yaml-cpp::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(Panzer_MPI_LIBRARIES "")
set(Panzer_MPI_LIBRARY_DIRS "")
set(Panzer_MPI_INCLUDE_DIRS "")
set(Panzer_MPI_EXEC "/usr/lib64/mpich/bin/mpiexec")
set(Panzer_MPI_EXEC_MAX_NUMPROCS "4")
set(Panzer_MPI_EXEC_NUMPROCS_FLAG "-np")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(Panzer_PACKAGE_LIST "PanzerMiniEM;PanzerAdaptersSTK;PanzerDiscFE;PanzerDofMgr;PanzerCore;Piro;ROL;Stokhos;Tempus;Rythmos;MueLu;NOX;Phalanx;Percept;STKExprEval;STKTransfer;STKSearch;STKIO;STKMesh;STKTopology;STKMath;STKUtil;Intrepid2;Intrepid;Teko;Stratimikos;Ifpack2;Anasazi;SEACASAprepro_lib;SEACASIoss;SEACASExodus;Amesos2;ShyLU_NodeBasker;ShyLU_NodeTacho;ShyLU_NodeHTS;Belos;ML;Ifpack;Zoltan2Core;Pamgen;Amesos;Galeri;AztecOO;Isorropia;Xpetra;Thyra;ThyraTpetraAdapters;ThyraEpetraExtAdapters;ThyraEpetraAdapters;ThyraCore;TrilinosSS;Tpetra;TpetraCore;TpetraTSQR;EpetraExt;Triutils;Shards;Zoltan;Epetra;MiniTensor;Sacado;RTOp;KokkosKernels;Teuchos;TeuchosKokkosComm;TeuchosKokkosCompat;TeuchosRemainder;TeuchosNumerics;TeuchosComm;TeuchosParameterList;TeuchosParser;TeuchosCore;Kokkos;KokkosSimd;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
set(Panzer_TPL_LIST "DLlib;Eigen;SCALAPACK;AMD;UMFPACK;SuperLU;Netcdf;HDF5;Zlib;Boost;LAPACK;BLAS;MPI;Pthread;yaml-cpp")

# Enables/Disables for upstream package dependencies
set(Panzer_ENABLE_PanzerCore ON)
set(Panzer_ENABLE_PanzerDofMgr ON)
set(Panzer_ENABLE_PanzerDiscFE ON)
set(Panzer_ENABLE_PanzerAdaptersSTK ON)
set(Panzer_ENABLE_PanzerMiniEM ON)
set(Panzer_ENABLE_PanzerExprEval OFF)

# Exported cache variables
set(Panzer_ENABLE_DEBUG "OFF")
set(PANZER_DEBUG "OFF")
set(Panzer_ENABLE_EXPLICIT_INSTANTIATION "ON")
set(HAVE_PANZER_EXPLICIT_INSTANTIATION "ON")

# Include configuration of dependent packages
if (NOT TARGET PanzerCore::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../PanzerCore/PanzerCoreConfig.cmake")
endif()
if (NOT TARGET PanzerDofMgr::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../PanzerDofMgr/PanzerDofMgrConfig.cmake")
endif()
if (NOT TARGET PanzerDiscFE::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../PanzerDiscFE/PanzerDiscFEConfig.cmake")
endif()
if (NOT TARGET PanzerAdaptersSTK::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../PanzerAdaptersSTK/PanzerAdaptersSTKConfig.cmake")
endif()
if (NOT TARGET PanzerMiniEM::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../PanzerMiniEM/PanzerMiniEMConfig.cmake")
endif()

# Import Panzer targets
include("${CMAKE_CURRENT_LIST_DIR}/PanzerTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(Panzer_EXPORTED_PACKAGE_LIBS_NAMES "panzer-core;panzer-dof-mgr;panzer-disc-fe;panzer-stk;panzer-mini-fe")

foreach(libname IN LISTS Panzer_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE Panzer::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'Panzer::${libname}', or better yet,"
      " 'Panzer::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'Panzer'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'Panzer_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
