# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/Teko clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "Teko requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/Teko build
## ---------------------------------------------------------------------------

set(Teko_CXX_COMPILER "/usr/lib64/mpich/bin/mpicxx")

set(Teko_C_COMPILER "/usr/lib64/mpich/bin/mpicc")

set(Teko_Fortran_COMPILER "/usr/lib64/mpich/bin/mpif90")
# Deprecated!
set(Teko_FORTRAN_COMPILER "/usr/lib64/mpich/bin/mpif90") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/Teko build
## ---------------------------------------------------------------------------

## Give the build type
set(Teko_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(Teko_CXX_FLAGS [[ ]])

set(Teko_C_FLAGS [[ -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -m64 -march=x86-64-v2 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fPIC -w -I/usr/include/mpich-x86_64 -fopenmp ]])

set(Teko_Fortran_FLAGS [[ ]])
# Deprecated
set(Teko_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(Teko_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(Teko_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64/mpich/lib")
set(Teko_BUILD_SHARED_LIBS "ON")

set(Teko_LINKER /usr/bin/ld)
set(Teko_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(Teko_INSTALL_DIR "/usr")

## List of package include dirs
set(Teko_INCLUDE_DIRS "")

## List of package library paths
set(Teko_LIBRARY_DIRS "")

## List of package libraries
set(Teko_LIBRARIES "Teko::teko;Stratimikos::stratimikos;Stratimikos::stratimikosbelos;Stratimikos::stratimikosamesos2;Stratimikos::stratimikosaztecoo;Stratimikos::stratimikosamesos;Stratimikos::stratimikosml;Stratimikos::stratimikosifpack;Ifpack2::ifpack2-adapters;Ifpack2::ifpack2;Anasazi::anasazitpetra;Anasazi::ModeLaplace;Anasazi::anasaziepetra;Anasazi::anasazi;Amesos2::amesos2;ShyLU_NodeBasker::shylu_nodebasker;ShyLU_NodeTacho::tacho;ShyLU_NodeHTS::shylu_nodehts;Belos::belosxpetra;Belos::belostpetra;Belos::belosepetra;Belos::belos;ML::ml;Ifpack::ifpack;Zoltan2Core::zoltan2;Amesos::amesos;Galeri::galeri-xpetra;Galeri::galeri-epetra;AztecOO::aztecoo;Isorropia::isorropia;Xpetra::xpetra-sup;Xpetra::xpetra;ThyraTpetraAdapters::thyratpetra;ThyraEpetraExtAdapters::thyraepetraext;ThyraEpetraAdapters::thyraepetra;ThyraCore::thyracore;TrilinosSS::trilinosss;TpetraCore::tpetraext;TpetraCore::tpetrainout;TpetraCore::tpetra;TpetraCore::tpetraclassic;TpetraTSQR::kokkostsqr;EpetraExt::epetraext;Triutils::triutils;Zoltan::zoltan;Epetra::epetra;RTOp::rtop;KokkosKernels::kokkoskernels;TeuchosKokkosComm::teuchoskokkoscomm;TeuchosKokkosCompat::teuchoskokkoscompat;TeuchosRemainder::teuchosremainder;TeuchosNumerics::teuchosnumerics;TeuchosComm::teuchoscomm;TeuchosParameterList::teuchosparameterlist;TeuchosParser::teuchosparser;TeuchosCore::teuchoscore;KokkosSimd::kokkossimd;KokkosAlgorithms::kokkosalgorithms;KokkosContainers::kokkoscontainers;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(Teko_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(Teko_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(Teko_TPL_LIBRARIES "DLlib::all_libs;Eigen::all_libs;SCALAPACK::all_libs;AMD::all_libs;UMFPACK::all_libs;SuperLU::all_libs;HDF5::all_libs;Zlib::all_libs;Boost::all_libs;LAPACK::all_libs;BLAS::all_libs;MPI::all_libs;Pthread::all_libs;yaml-cpp::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(Teko_MPI_LIBRARIES "")
set(Teko_MPI_LIBRARY_DIRS "")
set(Teko_MPI_INCLUDE_DIRS "")
set(Teko_MPI_EXEC "/usr/lib64/mpich/bin/mpiexec")
set(Teko_MPI_EXEC_MAX_NUMPROCS "4")
set(Teko_MPI_EXEC_NUMPROCS_FLAG "-np")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(Teko_PACKAGE_LIST "Teko;Stratimikos;Ifpack2;Anasazi;Amesos2;ShyLU_NodeBasker;ShyLU_NodeTacho;ShyLU_NodeHTS;Belos;ML;Ifpack;Zoltan2Core;Amesos;Galeri;AztecOO;Isorropia;Xpetra;Thyra;ThyraTpetraAdapters;ThyraEpetraExtAdapters;ThyraEpetraAdapters;ThyraCore;TrilinosSS;Tpetra;TpetraCore;TpetraTSQR;EpetraExt;Triutils;Zoltan;Epetra;RTOp;KokkosKernels;Teuchos;TeuchosKokkosComm;TeuchosKokkosCompat;TeuchosRemainder;TeuchosNumerics;TeuchosComm;TeuchosParameterList;TeuchosParser;TeuchosCore;Kokkos;KokkosSimd;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
set(Teko_TPL_LIST "DLlib;Eigen;SCALAPACK;AMD;UMFPACK;SuperLU;HDF5;Zlib;Boost;LAPACK;BLAS;MPI;Pthread;yaml-cpp")

# Enables/Disables for upstream package dependencies
set(Teko_ENABLE_Teuchos ON)
set(Teko_ENABLE_Thyra ON)
set(Teko_ENABLE_ThyraEpetraAdapters ON)
set(Teko_ENABLE_ThyraEpetraExtAdapters ON)
set(Teko_ENABLE_Stratimikos ON)
set(Teko_ENABLE_AztecOO ON)
set(Teko_ENABLE_Anasazi ON)
set(Teko_ENABLE_ML ON)
set(Teko_ENABLE_Ifpack ON)
set(Teko_ENABLE_Amesos ON)
set(Teko_ENABLE_Tpetra ON)
set(Teko_ENABLE_ThyraTpetraAdapters ON)
set(Teko_ENABLE_Isorropia ON)
set(Teko_ENABLE_Ifpack2 ON)
set(Teko_ENABLE_Amesos2 ON)
set(Teko_ENABLE_Belos ON)

# Exported cache variables
set(Ifpack2_Trilinos "ON")
set(HAVE_Teko_ENABLE_Ifpack2 "ON")

# Include configuration of dependent packages
if (NOT TARGET Teuchos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Teuchos/TeuchosConfig.cmake")
endif()
if (NOT TARGET Thyra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Thyra/ThyraConfig.cmake")
endif()
if (NOT TARGET ThyraEpetraAdapters::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ThyraEpetraAdapters/ThyraEpetraAdaptersConfig.cmake")
endif()
if (NOT TARGET ThyraEpetraExtAdapters::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ThyraEpetraExtAdapters/ThyraEpetraExtAdaptersConfig.cmake")
endif()
if (NOT TARGET Stratimikos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Stratimikos/StratimikosConfig.cmake")
endif()
if (NOT TARGET AztecOO::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../AztecOO/AztecOOConfig.cmake")
endif()
if (NOT TARGET Anasazi::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Anasazi/AnasaziConfig.cmake")
endif()
if (NOT TARGET ML::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ML/MLConfig.cmake")
endif()
if (NOT TARGET Ifpack::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Ifpack/IfpackConfig.cmake")
endif()
if (NOT TARGET Amesos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Amesos/AmesosConfig.cmake")
endif()
if (NOT TARGET Tpetra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Tpetra/TpetraConfig.cmake")
endif()
if (NOT TARGET ThyraTpetraAdapters::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ThyraTpetraAdapters/ThyraTpetraAdaptersConfig.cmake")
endif()
if (NOT TARGET Isorropia::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Isorropia/IsorropiaConfig.cmake")
endif()
if (NOT TARGET Ifpack2::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Ifpack2/Ifpack2Config.cmake")
endif()
if (NOT TARGET Amesos2::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Amesos2/Amesos2Config.cmake")
endif()
if (NOT TARGET Belos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Belos/BelosConfig.cmake")
endif()

# Import Teko targets
include("${CMAKE_CURRENT_LIST_DIR}/TekoTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(Teko_EXPORTED_PACKAGE_LIBS_NAMES "teko")

foreach(libname IN LISTS Teko_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE Teko::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'Teko::${libname}', or better yet,"
      " 'Teko::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'Teko'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'Teko_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
